program adccontrol;
{$N+ ,$E-,$F+,$G+,$L+,$D+,$S-}
{ Program to read Multislope data via UART }
uses com,crt,dos;
const   m = 15;              { output to screen every m results}
        k0 = 184.0+180 ;     { length of runup steps}
        k0b = 44.0+60;
        k1_puls = 25 ;       { lentgh of long K1 pulse}
        rulp = 16000/402;    { run-up counts/loops}
        { measured ref ratios from cal measurements: }
        k1 =  1.0 / 21.4403; { slow slope ratio }
        k2 =  4.0/139.6;     { fine step / adc LSB}

Var     k,c : char;
        n,m1,m2,outcnt : word;
	rawind,old_del : word;
        f, fkom  : text;
	old_diff,u,u1,u2,u3,du,u2old : double;   { voltages }
	ru : word;     { runup }
	rdp,rdn :word;  { rundown times }
	adc1, adc2 : longint;
        raw : array [0..50] of longint;
	sum, sum5,sum25 : longint;
	n5,n25 : word;
	sumA, sumB : longint;
        sumdu,avdu,sumq,rms :  double;

function checkscreen: boolean;
var avduold :double;
begin
 outcnt := outcnt +1;
 sumdu := sumdu+du;
 sumq := sumq + sqr(du-avdu);
 if outcnt = m then
  begin 
   outcnt := 0;
   checkscreen := true;
   avduold := avdu;
   avdu := sumdu/m;
   rms := sqrt((sumq - sqr(avdu-avduold)) / (m-1));
   sumdu := 0;
   sumq := 0;
  end
 else
 checkscreen := false;
end ;
		
procedure writetime(var f:text);
Var     h,s,y,m,day,dow : word;
begin
   getdate(y,m,day,dow);
   write(f,'# ',day,'.',m,'.',y,'   ');
   gettime(h,m,s,y);
   write(f,h,':',m,':',s);
   write(f,'# k0=',k0);
   write(f,' 1/k1=',1/k1:6:4);
   writeln(f,' 4/k2=',4/k2:6:2);
end;

function read8 :word;      { read value and remember}   
VAR  k : word;
begin
  k :=ord(Readcom(com1));   { low byte }
  raw[rawind] := k;         { remember raw values as words }
  rawind := rawind +1;
  read8 := k;
  end;
        		
function read16 :word;     
Var       k,k2  : word;
begin
  k :=ord(Readcom(com1));   { low byte }
  k2:=ord(Readcom(com1));
  k := 256 * k2 + k; 
  raw[rawind] := k;         { remember raw values as word }
  rawind := rawind +1;
  read16 := k;
  end;

function read24 :longint;
Var       k,k1,k2  :longint;
begin
  k :=ord(Readcom(com1));   { low byte }
  k1:=ord(Readcom(com1));
  k2:=ord(Readcom(com1));
  k := k + 256 * (k1 + 256 * k2); 
  raw[rawind] := k;         {remember raw values}
  rawind := rawind +1;
  read24 := k;
  end;
  

function readADC(k_0:double;n: integer):double ;
var  small, large :longint ;
begin
   ru := read16;
   small := read16;
   large := read16;
    adc2 := read16; { aux ADC }
    adc1 := read16;
    adc2 := read16;
    readADC := k_0 *(ru-rulp*n) *(2+k1) + (small - large*(1+k1) + (adc2-adc1)*k1*k2) ;
end;


Procedure Fileopen;
VAR     fn,kom : string;
begin
   fn := '';
   write('Filename '); Readln(fn);
   if fn = ''then fn := 'test.txt' ;
   assign(f,fn);
   rewrite(f);
   writetime(f);
   writeln(f,'# ',fn);
   write('kommentar '); Readln(kom);
   Writeln(f,'# ',kom);
   if fn <> 't' then begin
    assign(fkom,'log_kom.txt');
    append(fkom);
    writeln(fkom,fn,' ',kom);
    writetime(fkom);
    close(fkom);
   end;
end;   
   
procedure writeraw;   { write raw data to file (end of line)}
Var  i   :  word;
begin
 for i  := 0 to rawind-1 do
   write(f,' ',raw[i]);
 writeln(f);  
end;


begin
  outcnt := 0;
  sumdu :=0;
  sumq :=0;
  avdu :=0;
  u2old:=0;
  clrscr;
  InitCom (com1,b9600,none,D8,S1,no);
  Flushbuf(com1);
  writecom(com1,'B');
  if comallowed(com1) then writeln('com ist OK ');
  fileopen;
  
  k := ' '; 
  c:=Readcom(com1);
repeat     { main loop }
  if k <> ' ' then
  begin
   writecom(com1,k);
   k := ' '; 
  end;
  
  while (ord(c) <> 255 ) do
    c:=Readcom(com1);     {wait for sync}
  c:=Readcom(com1);     {get tag = type of data }
  n := ord(c);
  rawind := 0;
  write(f,n:4);   {type of data}
  IF (n = 254) or (n =251) then
   begin { AZ mode / test mode }
    u1 := readADC(k0,1);    { result of 1 st conversion }
    if n=254 then
     u2 := readADC(k0,1)    { result of 2. conversion }
    else
     u2 := readADC(k0b,3);   { result of 2. conversion,fast mode }
    du:=u1-0.5*(u2+u2old);

    write(f,' ',u1:8:3,' ',u2:8:3,' ',du:8:3,' ', adc1-adc2:6);
    writeraw;
    if checkscreen then
      writeln( ru,' ',u1:8:3,' ',u2:8:3,' ',du:8:3, ' ',-avdu*0.0416:9:4, adc1:5, rms:8:3);
    u2old := u2;
   end
  else IF n = 250 then
   begin {3 readings }
    u1 := readADC(k0,1);    { result of 1 st conversion }
    u2 := readADC(k0,1);    { result of 2. conversion }
    u3 := readADC(k0,1);    { result of 3. conversion }
    du:=u1-u2;
      write(f,' ',u1:8:3,' ',u2:8:3,' ',u3:8:3,' ', adc1-adc2:6);
    writeraw;
    if checkscreen then
      writeln( ru,' ',u1:8:3,' ',u2:8:3,' ',u3:8:3, ' ',-avdu*0.0416:9:4, adc1:5, rms:8:3);
    u2old := u2;
   end
  else IF n = 253 then
   begin {AdjustcyleK1}
     sum := read24;   { sum of slow slope lenght }
	  ru := read8;    { pulse length }
	  if ru = 5 then  { sum up data for long and short }
	   begin
	    sum5 := sum5 + sum;
		n5 := n5 + 1;
	   end;
	  if ru = k1_puls then  { long case }
	   begin
	    sum25 := sum25 + sum;
		n25 := n25 + 1;
	   end;
	 adc1 := read16;
	 adc1 := read16;
	 { writeraw;       { no result jet, only raw data }
   end
  else if n = 252 then
   begin 
	 m1 := read8;
	 m2 := read8;
	 sumA := read16;
	 sumB := read16;
	 adc1 := read16;   { for debug only, but need to read !}
	 adc2 := read16;
	 writeraw;
	 if n5 > 2 then 
	 begin  { data from adjustK1 there: }
	  u := (sum25 /n25 - sum5 /n5); { difference of average }
          u := u / (3*(k1_puls-5)*128);   { calculate slope ratio, include fixed constants }
	  write(f,'1  k1 = ', u:8:5);
	  writeln(f);
	  write('## k1 = ', u:8:5);
	  sum5 := 0;       {reset sums after use }
	  sum25 := 0; 
	  n5 :=0;
	  n25 := 0;
	 end;
	 if (m1 > 2) and (m2 >2) then
	 begin
	  u := sumA; u := u/m1;
	  u2 := 65536-sumB; u2 := u2/m2;     { U2 is negative }
	  { u := (u-u2) / (6.0/4);      { difference of up/down patterns }
	  write(f,'2  k2 = ', (u+u2)/2:8:5, u:8:3 , u2:8:3);
	  writeln(f);
	  writeln('## k2 : ', u:8:3 , u2:8:3 , m1:3,m2:3,(u+u2) / 2 :8:3);
	 end
   end
   else if n = 249 then
    begin   { test k2 , einfacher Test K2}
      m1 := read8;   { valid - should be 60 }
      m2 := read8;   { delay }
      sumA := read16;
      sumB := read16;
      if m1 = 60 then
       begin
         if old_del = m2-1 then
          begin
           write( (sumA-sumB)/60 - old_diff:8:2,'  ');
          end;
         write(f,' ', (sumA-sumB)/60 :6:3);   {average ADC diff }
         writeln((sumA-sumB)/60 :6:3);
      
         old_del  := m2;
         old_diff :=(sumA-sumB)/60;
       end
      else
       begin
        write(f,'  0 '); { no valid number }
        old_del := 0 ;
       end;
      writeraw; 
    end;

   if keypressed then k := upcase(readkey);
   until (k = 'X');
  close (f); 
  
  exitcom(com1); { remove com input }
end.